/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.15 from the
 * contents of GstStructure.xs. Do not edit this file, edit GstStructure.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "xs/GstStructure.xs"
/*
 * Copyright (C) 2005 by the gtk2-perl team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: GstStructure.xs,v 1.3 2005/12/03 00:28:13 kaffeetisch Exp $
 */

#include "gst2perl.h"

/* ------------------------------------------------------------------------- */

/* SvGstStructure returns a newly allocated structure which does *not* get
 * freed when the next LEAVE is reached.  So the caller must take ownership. */
GstStructure *
SvGstStructure (SV *sv)
{
	GstStructure *structure;
	HV *hv;
	SV **name, **fields;

	if (!SvOK (sv) || !SvRV (sv) || SvTYPE (SvRV (sv)) != SVt_PVHV)
		croak ("GstStructure must be a hash reference");

	hv = (HV *) SvRV (sv);

	name = hv_fetch (hv, "name", 4, 0);
	if (!name || !SvOK (*name))
		croak ("GstStructure must contain a 'name' key");

	/* This leaks the structure when we croak further down, but I think
	 * that's ok since errors here are rather fatal. */
	structure = gst_structure_empty_new (SvPV_nolen (*name));

	fields = hv_fetch (hv, "fields", 6, 0);
	if (fields && SvOK (*fields)) {
		AV *fields_av;
		int i;

		if (!SvRV (*fields) || SvTYPE (SvRV (*fields)) != SVt_PVAV)
			croak ("The value of the 'fields' key must be an array reference");

		fields_av = (AV *) SvRV (*fields);

		for (i = 0; i <= av_len (fields_av); i++) {
			SV **field, **field_name, **field_type, **field_value;
			AV *field_av;

			field = av_fetch (fields_av, i, 0);

			if (!field || !SvOK (*field) || !SvRV (*field) || SvTYPE (SvRV (*field)) != SVt_PVAV)
				croak ("The 'fields' array must contain array references");

			field_av = (AV *) SvRV (*field);

			if (av_len (field_av) != 2)
				croak ("The arrays in the 'fields' array must contain three values: name, type, and value");

			field_name = av_fetch (field_av, 0, 0);
			field_type = av_fetch (field_av, 1, 0);
			field_value = av_fetch (field_av, 2, 0);

			if (field_name && SvOK (*field_name) &&
			    field_type && SvOK (*field_type) &&
			    field_value && SvOK (*field_value)) {
				GValue value = { 0, };

				g_value_init (&value, gperl_type_from_package (SvPV_nolen (*field_type)));
				gperl_value_from_sv (&value, *field_value);
				gst_structure_set_value (structure, SvGChar (*field_name), &value);

				g_value_unset (&value);
			}
		}
	}

	return structure;
}

static gboolean
fill_av (GQuark field_id,
         const GValue *value,
         gpointer user_data)
{
	AV *fields = (AV *) user_data;

	const gchar *id = g_quark_to_string (field_id);
	const char *type = gperl_package_from_type (G_VALUE_TYPE (value));

	/* Use the C name if there's no Perl name. */
	if (!type)
		type = g_type_name (G_VALUE_TYPE (value));

	AV *field = newAV ();

	av_push (field, newSVGChar (id));
	av_push (field, newSVpv (type, PL_na));
	av_push (field, gperl_sv_from_value (value));

	av_push (fields, newRV_noinc ((SV *) field));

	return TRUE;
}

SV *
newSVGstStructure (const GstStructure *structure)
{
	HV *hv;
	AV *av;
	const gchar *name;

	if (!structure)
		return &PL_sv_undef;

	hv = newHV ();
	av = newAV ();

	name = gst_structure_get_name (structure);
	hv_store (hv, "name", 4, newSVGChar (name), 0);

	gst_structure_foreach (structure, fill_av, av);
	hv_store (hv, "fields", 6, newRV_noinc ((SV *) av), 0);

	return newRV_noinc ((SV *) hv);
}

/* ------------------------------------------------------------------------- */

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 155 "xs/GstStructure.c"

XS(XS_GStreamer__Structure_to_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_GStreamer__Structure_to_string)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: GStreamer::Structure::to_string(structure)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	gchar_own *	RETVAL;
	const GstStructure *	structure = SvGstStructure (ST(0));

	RETVAL = gst_structure_to_string(structure);
	ST(0) = sv_newmortal();
	/* used when we can directly own the returned string. */
	/* we have to copy in the case when perl's malloc != gtk's malloc,
         * so best copy all the time. */
	sv_setpv ((SV*)ST(0), RETVAL);
	SvUTF8_on (ST(0));
        g_free (RETVAL);

    }
    XSRETURN(1);
}


XS(XS_GStreamer__Structure_from_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_GStreamer__Structure_from_string)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: GStreamer::Structure::from_string(string)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const gchar *	string;
#line 169 "xs/GstStructure.xs"
	gchar *end = NULL;
	GstStructure *structure;
#line 196 "xs/GstStructure.c"

	/* same as SvGChar(), but not in a function */
	sv_utf8_upgrade (ST(0));
	string = (const gchar *)SvPV_nolen (ST(0));
#line 172 "xs/GstStructure.xs"
	structure = gst_structure_from_string (string, &end);
	EXTEND (sp, 2);
	PUSHs (sv_2mortal (newSVGstStructure (structure)));
	PUSHs (sv_2mortal (newSVGChar (end)));
	gst_structure_free (structure);
#line 207 "xs/GstStructure.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_GStreamer__Structure); /* prototype to pass -Wmissing-prototypes */
XS(boot_GStreamer__Structure)
{
    dXSARGS;
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("GStreamer::Structure::to_string", XS_GStreamer__Structure_to_string, file);
        newXS("GStreamer::Structure::from_string", XS_GStreamer__Structure_from_string, file);
    XSRETURN_YES;
}

